#include<iostream>
using namespace std;

int main() {

	int n,q;
	cin>>n>>q;
	long long a[n];
	for(int i=0;i<n;i++){
		cin>>a[i];
	}
	int l[q];
	int r[q];
	for(int i=0;i<q;i++){
		cin>>l[i];
		cin>>r[i];
	}
	int count = 0;
	int max = -1;
     for(int k = 0;k<q;k++){
     	for(int i=l[k]-1;i<r[k];i++){
     	for(int j=i;j<r[k];j++){
     		if((a[i] & a[j]) > (a[i] ^ a[j])){
     			count++;
			 }
		 }
         if(count > max){
         	max = count;
		 }
		 count = 0;
		 }
		 cout<<max<<endl;
		 max = -1;
	 }
	 
return 0;
}